﻿Rem
bbdoc:   TLabel
returns: :TLabel
End Rem
Type TLabel Extends Gadget
	Field Vather:twindow, Press:Int, OT:String
	
	Method Draw(SX:Int = 0, SY:Int = 0)
		Local DX:Int = X + SX
		Local DY:Int = y + sy
		Local A:Float = GetAlpha()
		
		GuiText Text, DX, DY, R, G, B

		SetAlpha A
		SetColor 255, 255, 255
	End Method
	
	Method Update:Int(SX:Int = 0, SY:Int = 0)
		Local DX:Int = X + SX
		Local DY:Int = y + sy
		
		If Text <> OT Then
			OT = Text
			W = TextWidth(Text)
		End If
		
		If Vather = Null Then
			If Over() = 0 Then
				If GetMouse(DX, DY, W, H) = 1 Then
					Activ = 1
					If MouseDown(1) Then Press = 1 FlushMouse() Return 1
				Else
					Activ = 0
				EndIf
			Else
				Activ = 0
			EndIf
		Else
			If GetMouse(DX, DY, W, H) = 1 Then
				Activ = 1

				If MouseDown(1) Then Press = 1 FlushMouse() Return 1
			Else
				Activ = 0
			EndIf
		EndIf
	End Method
End Type

Rem
bbdoc:   Gibt aus ob der Label nun Gedrückt wurde, wenn ja Rückgabe=1 andernfalls 0
returns: :Int
End Rem
Function LabelPress:Int(L:TLabel)
	If L Then
		Local P:Int = l.Press
		L.Press = 0
		Return P
	End If
End Function

Rem
bbdoc:   Wenn die Maus sich auf dem Label befindet wird eine 1 zurückgegeben
returns: :Int
End Rem
Function LabelOver:Int(L:TLabel)
	If L Then
		Return L.Activ
	End If
End Function

Rem
bbdoc:   Ein Label erstellen (Text:String, X:Int, Y:Int, Win:TWindow = Null)
returns: :TLabel
End Rem
Function NewLabel:TLabel (Text:String, X:Int, Y:Int, Win:TWindow = Null)
	Local L:TLabel = New TLabel
	L.Text = Text
	L.X = X
	L.Y = Y
	l.W = TextWidth(Text)
	l.H = TextHeight ("W")
	L.Vather = win
	l.SetStandart
	
	If Win = Null Then
		Gadget.List.AddLast L
	Else
		win.Inhalt.AddLast L
	End If
	Return L
End Function