Rem
bbdoc:   TSlider
returns: :TSlider
End Rem
Type TSlider Extends gadget
	Field SvX:Float, SvY:Float, Pos:Float, Range0:Float, Range1:Float, SType:Int, Vather:TWindow, Faktor1:Float, Faktor2:Float, Move:Int
	
	Method Draw(SX:Int = 0, SY:Int = 0)
		Local DX:Int = x + SX
		Local DY:Int = y + sy
		Local A:Float = GetAlpha()
		
		SetColor R, G, B
		SetAlpha 1
		Rect DX, DY, W, H
		
		SetAlpha 0.3
		SetColor R - 200, G - 200, B - 200
		Rect DX + 1, DY + 1, W - 1, H - 1, 1
		SetColor R, G, B
		
		SetAlpha 0.3
		If Activ = 1 Then SetAlpha 0.4
		
		
		If SType = 0 Then
			
			Rect DX + 1, DY + 1 + Pos, W - 2, Float((H - 2)) * Faktor2, 1
			SetAlpha 1
			SetBlend ALPHABLEND
			SetColor 0, 0, 0
			Rect DX + 1, DY + 1 + Pos, W - 2, Float((H - 2)) * Faktor2, 0
		EndIf
		
		If SType = 1 Then
			Rect DX + 1 + Pos, DY + 1, Float((W - 2)) * Faktor2, H - 2, 1
			SetAlpha 1
			SetBlend ALPHABLEND
			SetColor 0, 0, 0
			Rect DX + 1 + Pos, DY + 1, Float((W - 2)) * Faktor2, H - 2, 0
		End If
		
		SetColor 255, 255, 255
		SetAlpha 1
	End Method
	
	Method Update:Int(SX:Int = 0, SY:Int = 0)
		If SType = 0 Then
			Faktor1 = Range0 / Float((H - 2))
			Faktor2 = Range0 / Range1
		EndIf
	
		If SType = 1 Then
			Faktor1 = Range0 / Float((W - 2))
			Faktor2 = Range0 / Range1
		EndIf
		
		Local DX:Int = x + SX
		Local DY:Int = y + sy
			
		If MouseDown(1) Then
			If SType = 0 And Move = 1 Then
				Pos = MouseY() - SvY
				
				If Pos < 0 Then Pos = 0
				If Pos + Float((H - 2)) * Faktor2 > H - 1 Then Pos = H - 1 - Float((H - 2)) * Faktor2
				Return 1
			End If
			
			If SType = 1 And Move = 1 Then
				Pos = MouseX() - SvX
				
				If Pos < 0 Then Pos = 0
				If Pos + Float((W - 2)) * Faktor2 > W - 1 Then Pos = W - 1 - Float((W - 2)) * Faktor2
				Return 1
			End If
		Else
			If Pos < 0 Then Pos = 0
			If SType = 0 Then
				If Pos + Float((H - 2)) * Faktor2 > H - 1 Then Pos = H - 1 - Float((H - 2)) * Faktor2
			Else
				If Pos + Float((W - 2)) * Faktor2 > W - 1 Then Pos = W - 1 - Float((W - 2)) * Faktor2
			EndIf
			If Move = 1 Then Move = 0 Return 1
		EndIf
		
		If Vather = Null Then
			If Over() = 0 Then
				If SType = 0 Then
					If GetMouse(DX, DY + Pos, W, Float((H - 2)) * Faktor2) = 1 Then
						Activ = 1
						If MouseDown(1) Then
							If Move = 0 Then
								SvY = MouseY() - Pos
								Move = 1
								Return 1
							End If
						EndIf
					Else
						Activ = 0
					EndIf
				EndIf
				
				If SType = 1 Then
					If GetMouse(DX + Pos, DY, Float((W - 2)) * Faktor2, H) = 1 Then
						Activ = 1
						If Move = 0 Then
							SvX = MouseX() - Pos
							Move = 1
							Return 1
						End If
					Else
						Activ = 0
					EndIf
				EndIf
			Else
				Activ = 0
			EndIf
		Else
			If SType = 0 Then
				If GetMouse(DX, DY + Pos, W, Float((H - 2)) * Faktor2) = 1 Then
					Activ = 1
	
					If Move = 0 Then
						SvY = MouseY() - Pos
						Move = 1
						Return 1
					End If
				Else
					Activ = 0
				EndIf
			EndIf
			
			If SType = 1 Then
				If GetMouse(DX + Pos, DY, Float((W - 2)) * Faktor2, H) = 1 Then
					Activ = 1
	
					If Move = 0 Then
						SvX = MouseX() - Pos
						Move = 1
						Return 1
					End If
				Else
					Activ = 0
				EndIf
			EndIf
		EndIf
	End Method
End Type

Rem
bbdoc:   Einen neuen Slider erstellen. (X:Int, Y:Int, W:Int, H:Int, Vertikal:Int = 0, Win:TWindow = Null)
returns: :TSlider
End Rem
Function NewSlider:TSlider (X:Int, Y:Int, W:Int, H:Int, Vertikal:Int = 0, Win:TWindow = Null)
	Local S:TSlider = New TSlider
	S.X = X
	S.Y = Y
	S.W = W
	S.H = H
	S.SType = Vertikal
	S.Vather = Win
	S.SetStandart
	
	s.Range0 = 1
	s.Range1 = 1
	
	If Win = Null Then
		Gadget.List.AddLast S
	Else
		Win.Inhalt.AddLast S
	End If
	Return S
End Function

Rem
bbdoc:   Slider Range festlegen.
returns: -
End Rem
Function SliderRange(S:TSlider, Range0:Float, Range1:Float)
	S.Range0 = Range0
	S.Range1 = Range1
	
	If s.SType = 0 Then
		s.Faktor1 = s.Range0 / Float((S.H - 2))
		s.Faktor2 = s.Range0 / s.Range1
	EndIf
	
	If s.SType = 1 Then
		s.Faktor1 = s.Range0 / Float((s.W - 2))
		s.Faktor2 = s.Range0 / s.Range1
	EndIf
End Function

Rem
bbdoc:   Slider Wert ausgeben
returns: :Float
End Rem
Function GetSliderRange:Float(S:TSlider)
	Return S.Pos / S.Faktor2 * S.Faktor1
End Function