﻿Rem 
bbdoc:   TListBox
returns: :TListBox
End Rem
Type TListBox Extends Gadget
	Field Slider:TSlider, Inhalt:TList, MH:Float, Eingetragen:Int, ZW:Int, OverID:Int, Press:TListBox, Vather:TWindow, InahltName:String, InhaltImage:TImage, TxR:Int, TxB:Int, TxG:Int, InhaltTile:Int, Area:TListBox
	
	Method Draw(SX:Int = 0, SY:Int = 0)
		Local DX:Int = x + SX
		Local DY:Int = y + sy
		Local A:Float = GetAlpha()
		
		SetColor R, G, B
		SetAlpha 1
		Rect DX, DY, W, H
		SetAlpha 0.6
		Rect DX + 1, DY + 1, W - 17, H - 1, 1
		
		SetViewport DX + 1, DY + 1, W - 17, H - 1
			
		Local EinTX:Int = 0, IDx:Int = 0
		For Local EL:TListBox = EachIn Inhalt
			If EinTX - GetSliderRange(Slider) > - MH And EinTX - GetSliderRange(Slider) < H + MH Then
				If EL.InhaltImage Then SetAlpha 1 SetColor 255, 255, 255 SetBlend ALPHABLEND DrawImage EL.InhaltImage, DX + 2, DY + 2 + EinTX - GetSliderRange(Slider), EL.InhaltTile SetColor R, G, B
				If IDx = OverID Then
					SetAlpha 0.9
				Else
					SetAlpha 0.4
				EndIf
				SetBlend LIGHTBLEND
				SetColor TxR, TxG, TxB
				
				DrawText EL.InahltName, DX + 2 + ZW, DY + 2 + EinTX - GetSliderRange(Slider)
				SetBlend ALPHABLEND
			EndIf
			EinTX = EinTX + MH
			IDx = IDx + 1
		Next
		SetViewport 0, 0, GraphicsWidth(), GraphicsHeight()
		
		SetAlpha 1
		SetColor 255, 255, 255
	End Method
	
	Method Update:Int(SX:Int = 0, SY:Int = 0)
		Slider.Color R, G, B
		
		Local DX:Int = x + SX
		Local DY:Int = y + sy
		
		If Vather = Null Then
			If Over() = 0 Then
				If GetMouse(DX, DY, W - 17, H) = 1 Then
					Activ = 1
					Local EinTX:Int = 0, IDx:Int = 0
					For Local EL:TListBox = EachIn Inhalt
						If EinTX - GetSliderRange(Slider) > - MH And EinTX - GetSliderRange(Slider) < H + MH Then
							If MouseDown(1) Then
								If GetMouse(DX + 2 , DY + 2 + EinTX - GetSliderRange(Slider), W - 17, MH) = 1 Then Press = EL FlushMouse() Exit
							Else
								If GetMouse(DX + 2, DY + 2 + EinTX - GetSliderRange(Slider), W - 17, MH) = 1 Then OverID = IDx Exit
							EndIf
						EndIf
						EinTX = EinTX + MH
						IDx = IDx + 1
					Next
					
				Else
					OverID = -1
					Activ = 0
				EndIf
			Else
				Activ = 0
				OverID = -1
			EndIf
		Else
			If GetMouse(DX, DY, W - 17, H) = 1 Then
				Activ = 1
				Local EinTX:Int = 0, IDx:Int = 0
				For Local EL:TListBox = EachIn Inhalt
					If EinTX - GetSliderRange(Slider) > - MH And EinTX - GetSliderRange(Slider) < H + MH Then
						If MouseDown(1) Then
							If GetMouse(DX + 2, DY + 2 + EinTX - GetSliderRange(Slider), W - 17, MH) = 1 Then Press = EL FlushMouse() Exit
						Else
							If GetMouse(DX + 2, DY + 2 + EinTX - GetSliderRange(Slider), W - 17, MH) = 1 Then OverID = IDx Exit
						EndIf
					EndIf
					EinTX = EinTX + MH
					IDx = IDx + 1
				Next
				
			Else
				Activ = 0
				OverID = -1
			EndIf
		EndIf
	End Method
End Type

Rem 
bbdoc:   Erstellen einer neuen ListBox Area (X:Int, Y:Int, W:Int, H:Int, TextR:Int = 255, TexTG:Int = 255, TextB:Int = 255, Win:TWindow = Null)
returns: TListBox
End Rem
Function NewListBox:TlistBox(X:Int, Y:Int, W:Int, H:Int, TextR:Int = 255, TexTG:Int = 255, TextB:Int = 255, Win:TWindow = Null)
	Local L:TlistBox = New TlistBox
	L.X = X
	L.Y = Y
	L.W = W - 16
	L.H = H
	
	L.Slider = NewSlider (l.X + l.W - 15, l.Y, 15, l.H, 0, win)
		
	L.Inhalt = New TList
	
	L.Vather = Win
	L.SetStandart
	
	L.OverID = -1
	L.Press = Null
	
	L.TxR = TextR
	L.Txg = TexTG
	L.Txb = TextB
	
	If Win = Null Then
		Gadget.List.AddLast L
	Else
		Win.Inhalt.AddLast L
	End If
	Return L
End Function

Rem 
bbdoc:   Etwas in einer ListBox eintragen
returns: TListBox
End Rem
Function ADDListBoxEnemy:TlistBox(L:TlistBox, Text:String, Image:TImage = Null, Tile:Int = 0)
	Local Eintrag:TlistBox = New TlistBox
	Eintrag.InahltName = Text
	Eintrag.InhaltImage = Image
	Eintrag.InhaltTile = Tile
	Eintrag.Area = L
	
	L.Eingetragen = L.Eingetragen + 1
	
	Local Hoher:Float = l.MH
	
	If hoher < TextHeight("W") Then hoher = TextHeight("W")
	
	If Image Then
		If Image.height > Hoher Then Hoher = Image.height
		If Image.width > L.ZW Then L.ZW = Image.width
	End If
	
	If Gadget.TH > Hoher Then Hoher = Gadget.TH
	
	L.MH = Hoher
	
	If L.H - 2 - 4 > L.Eingetragen * L.MH Then
		SliderRange(L.Slider, 1, 1)
	Else
		SliderRange(L.Slider, L.H - 2 - 4, L.Eingetragen * L.MH)
	EndIf
		
	L.Inhalt.AddLast Eintrag
	Return Eintrag
End Function

Rem 
bbdoc:   Einen ListBox Eintrag löschen
returns: -
End Rem
Function REMListBoxEnemy(L:TListBox, Eintrag:TListBox)
	If Eintrag <> Null Then
		L.Inhalt.Remove Eintrag
		L.Eingetragen = L.Eingetragen - 1
		If L.H - 2 - 4 > L.Eingetragen * L.MH Then
			SliderRange(L.Slider, 1, 1)
		Else
			SliderRange(L.Slider, L.H - 2 - 4, L.Eingetragen * L.MH)
		EndIf
	EndIf
End Function

Rem 
bbdoc:   Activer Listbox eintrag herrausfinden
returns: TListBox
End Rem
Function SelectListBox:TListBox (L:TListBox)
	Local TempPress:TListBox
	
	If L.Press <> Null Then TempPress = L.Press
	L.Press = Null
	
	Return TempPress
End Function

Rem 
bbdoc:   Gibt den Text vom Item in der Listbox aus
returns: String
End Rem
Function GetListBoxEnemyText:String(L:TListBox)
	Return L.InahltName
End Function

Rem 
bbdoc:   Modifiziert einen vorhandenen Eintrag
returns: -
End Rem
Function ModifyListBoxEnemy(Eintrag:TListBox, Text:String, Image:TImage, Tile:Int)
	Eintrag.InhaltImage = Image
	Eintrag.InahltName = Text
	Eintrag.InhaltTile = Tile
	
	If Image Then
		If Image.Height > Eintrag.Area.MH Then Eintrag.Area.MH = Image.height
		If Image.width > Eintrag.Area.ZW Then Eintrag.Area.ZW = Image.width
	End If
	
End Function